/*!
 * \file   /utl/impl/concepts.h
 * \brief  Concept support header
 *
 * Copyright (C) 2018 Christos Choutouridis
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#ifndef __utl_impl_concepts_h__
#define __utl_impl_concepts_h__

/*!
 * utl inner concept preprocessor flag
 * \defgroup crtp
 * \ingroup impl
 */
//!@{
#if defined __cpp_concepts
#define _utl_have_concepts (1)
#endif

/*!
 * requires keyword wrapper
 */
#if defined _utl_have_concepts
   #define _requires(_r_) requires (_r_)
#else
   #define _requires(_r_)
#endif

//!@}
#endif /* __utl_impl_concepts_h__ */
